; 

    include \masm32\include\masm32rt.inc
    .686
    include \masm32\macros\timers.asm

    dayofweek PROTO C d:DWORD, m:DWORD, y:DWORD
    dayofweek2 PROTO C d:DWORD, m:DWORD, y:DWORD
    dayofweek_gcc PROTO C d:DWORD, m:DWORD, y:DWORD
    dayofweek2_gcc PROTO C d:DWORD, m:DWORD, y:DWORD

; 
    .data
    .code
; 

option   prologue:none
option   epilogue:none
; Work out what the day of the week is for a given date
; C Algorithm by Tomohiko Sakamoto
; int dayofweek(int d, int m, int y) {
;   static int t[] = { 0, 3, 2, 5, 0, 3, 5, 1, 4, 6, 2, 4 };
;   y -= m < 3;
;   return ( y + y/4 - y/100 + y/400 + t[m-1] + d) % 7;
; }
; year  = [1, 9999+]; month = [1, 12]; day   = [1, 31]
; MASM algo by Lingo - 7 clocks
; Return: eax=0(Su) or 1(Mo) or 2(Tu) or 3 (We) or 4 (Th) or 5(Fr) or 6(Sa)

align 16

monthdata dd 0,0,3,2,5,0,3,5,1,4,6,2,4,0,1,2

DayOfTheWeek proc year:DWORD, month:DWORD, day:DWORD

  pop  eax                      ; return address
  pop  edx                      ; edx->years
  pop  eax                      ; eax->month
  cmp  eax, 3                   ; test if month is < 3
  pop  ecx                      ; ecx->day
  sbb  edx, 0                   ; if month < 3 then dec edx->years
  add  ecx, [monthdata + eax*4] ; ecx-> monthdata[month-1] +day
  mov  eax, edx                 ; eax=edx=years
  shr  eax, 2                   ; eax= years/4
  add  ecx, edx                 ; ecx-> monthdata[month-1] +day+years
  imul edx, 0A3D8h              ; dividing edx=years by 100 == imul edx,0A3D8h / shr edx, 22
  add  eax, ecx                 ; eax= monthdata[month-1] +day+years+ years/4
  shr  edx, 22                  ; end of dividing ; edx=years/100
  sub  eax, edx                 ; eax= monthdata[month-1] +day+years+ years/4- years/100
  shr  edx, 2                   ; edx=years/400
  add  eax, edx                 ; eax= monthdata[month-1] +day+years+ years/4-years/100+years/400
  mov  edx, 24924925h           ; dividing eax by 7 == mul edx, eax ; 24924925h=dword (1/7 * 2^35)
  mov  ecx, eax                 ; ecx=eax=monthdata[month-1]  + day+years+years/4-years/100+years/400
  mul  edx                      ; dividing eax by 7 ->result in edx
  add  ecx, edx                 ; add n/7 to ecx(n)
  neg  edx                      ; edx-> -n/7 ;-> ecx+ ecx/7 - 8*ecx/7 = ecx -  7*ecx/7 = ecx  % 7
  lea  eax, [ecx+edx*8]         ; eax= (monthdata[month-1] + day + years + years/4 - years/100 + years/400) % 7
  jmp  dword ptr [esp-4*4]      ; jmp to return address

DayOfTheWeek  endp

option   prologue:prologuedef
option   epilogue:epiloguedef

; 
start:
; 
    invoke DayOfTheWeek, 2009, 4, 11
    print str$(eax),13,10
    invoke dayofweek, 11, 4, 2009
    print str$(eax),13,10
    invoke dayofweek2, 11, 4, 2009
    print str$(eax),13,10
    invoke dayofweek_gcc, 11, 4, 2009
    print str$(eax),13,10
    invoke dayofweek2_gcc, 11, 4, 2009
    print str$(eax),13,10,13,10

    invoke Sleep, 4000

    counter_begin 1000, HIGH_PRIORITY_CLASS
      invoke DayOfTheWeek, 2009, 4, 11
    counter_end
    print ustr$(eax)," cycles, DayOfTheWeek",13,10

    counter_begin 1000, HIGH_PRIORITY_CLASS
      invoke dayofweek, 11, 4, 2009
    counter_end
    print ustr$(eax)," cycles, dayofweek",13,10

    counter_begin 1000, HIGH_PRIORITY_CLASS
      invoke dayofweek2, 11, 4, 2009
    counter_end
    print ustr$(eax)," cycles, dayofweek2",13,10

    counter_begin 1000, HIGH_PRIORITY_CLASS
      invoke dayofweek_gcc, 11, 4, 2009
    counter_end
    print ustr$(eax)," cycles, dayofweek_gcc",13,10

    counter_begin 1000, HIGH_PRIORITY_CLASS
      invoke dayofweek2_gcc, 11, 4, 2009
    counter_end
    print ustr$(eax)," cycles, dayofweek2_gcc",13,10,13,10

    inkey "Press any key to exit..."
    exit
; 
end start
